#include <stdio.h>
#include <imsls.h>
int main(){                                
   float *trainStats;
   int i, j, k, m;
   int n_patterns =48;  /* # of training patterns */
   int n_inputs   =9;   /* 2 nominal (7 classes) and 2 continuous */
   int n_nominal  =7;   /* 2 attributes with 3 and 4 classes each */
   int n_continuous =2; /* 2 continuous input attributes */
   int n_outputs     =1;    /* binary classification */
   int classification[48];
   int nominalAtt[48*7];
   int n_cat = 2;
   int nomTempIn[48], *nomTempOut, nClass;
   float inputData[5*48] =
   {
      0.00, 0.00, 0, 0, 0, 0.02, 0.02, 0, 1, 0, 0.04, 0.04, 0, 2, 0,
         0.06, 0.06, 0, 3, 0, 0.08, 0.08, 1, 0, 0, 0.10, 0.10, 1, 1, 0,
         0.12, 0.12, 1, 2, 0, 0.14, 0.14, 1, 3, 0, 0.16, 0.16, 2, 0, 0,
         0.18, 0.18, 2, 1, 0, 0.20, 0.20, 2, 2, 0, 0.22, 0.22, 2, 3, 0,
         0.24, 0.28, 0, 0, 0, 0.26, 0.30, 0, 1, 0, 0.28, 0.32, 0, 2, 0,
         0.30, 0.34, 0, 3, 0, 0.32, 0.36, 1, 0, 0, 0.34, 0.38, 1, 1, 0,
         0.36, 0.40, 1, 2, 0, 0.38, 0.42, 1, 3, 0, 0.40, 0.44, 2, 0, 0,
         0.42, 0.46, 2, 1, 0, 0.44, 0.48, 2, 2, 0, 0.46, 0.50, 2, 3, 0,
         0.52, 0.48, 0, 0, 0, 0.54, 0.50, 0, 1, 1, 0.56, 0.52, 0, 2, 1,
         0.58, 0.54, 0, 3, 1, 0.60, 0.56, 1, 0, 1, 0.62, 0.58, 1, 1, 1,
         0.64, 0.60, 1, 2, 1, 0.66, 0.62, 1, 3, 1, 0.68, 0.64, 2, 0, 0,
         0.70, 0.66, 2, 1, 0, 0.72, 0.68, 2, 2, 0, 0.74, 0.70, 2, 3, 0,
         0.76, 0.76, 0, 0, 1, 0.78, 0.78, 0, 1, 1, 0.80, 0.80, 0, 2, 1,
         0.82, 0.82, 0, 3, 1, 0.84, 0.84, 1, 0, 1, 0.86, 0.86, 1, 1, 1,
         0.88, 0.88, 1, 2, 1, 0.90, 0.90, 1, 3, 1, 0.92, 0.92, 2, 0, 0,
         0.94, 0.94, 2, 1, 0, 0.96, 0.96, 2, 2, 0, 0.98, 0.98, 2, 3, 0
   };
   float contAtt[2*48];
   float *classProb;
   char *colLabels[] = {"Pattern", "Class=0", "Class=1"};
   Imsls_f_NN_Network *network;

   printf("\n***********************************\n");
   printf("*  BINARY CLASSIFICATION EXAMPLE  *\n");
   printf("***********************************\n\n");

	imsls_omp_options(IMSLS_SET_FUNCTIONS_THREAD_SAFE, 1, 0);

   /*  Setup Continuous Input Attributes and  
    *  Classification Target Arrays
    */
   for(i=0; i<n_patterns; i++){
      /* Assign input to array for continuous input attributes */
      contAtt[2*i]    = inputData[i*5];
      contAtt[2*i+1]  = inputData[i*5+1];
      /* Assign input to classification target array*/
      classification[i] = (int) inputData[i*5+4];
   }  

   /* Setup Nominal Input Attributes Using Binary Encoding */
   m=0;
   for(i=0; i<n_cat; i++){
      for(j=0; j<n_patterns; j++){
         nomTempIn[j] = (int) inputData[j*5+n_continuous+i]+1; 
      }
      nomTempOut = imsls_unsupervised_nominal_filter(n_patterns, 
         &nClass, nomTempIn, 0);
      for(k=0; k<nClass; k++){
         for(j=0; j<n_patterns; j++){
            nominalAtt[j*n_nominal+m] = nomTempOut[j*nClass+k]; 
         }
         m++;
      }
      imsls_free(nomTempOut);
   }

   printf("\t  TRAINING PATTERNS\n");
   printf("\tY   N1 N2    Z1     Z2 \n");
   for(i=0; i<n_patterns; i++){
      j = (int) inputData[i*5+2];
      k = (int) inputData[i*5+3];
      printf("\t%d   %d  %d    %g   %g \n", classification[i], j, k,
         contAtt[i*2], contAtt[i*2+1]);
   }

   printf("\n");
   network = imsls_f_mlff_network_init(n_inputs, n_outputs);
   imsls_f_mlff_network(network, 
      IMSLS_CREATE_HIDDEN_LAYER, 3, 
      0);
   imsls_f_mlff_network(network, 
      IMSLS_CREATE_HIDDEN_LAYER, 2,
      IMSLS_LINK_ALL, 
      0);

   /* Note the following statement is for repeatable output */
   imsls_random_seed_set(5555);
   /* Train Classification Network */
   printf("STARTING NETWORK TRAINING\n");
   trainStats = imsls_f_mlff_classification_trainer (network,
      n_patterns, n_nominal, n_continuous, classification,
      nominalAtt, contAtt, 
      IMSLS_PRINT, 
      IMSLS_PREDICTED_CLASS_PROB, &classProb,
      0);

   /* Print class predictions*/
   imsls_f_write_matrix("Predicted Classification Probabilities", 
      n_patterns, n_outputs , classProb,
      IMSLS_ROW_NUMBER, 
      IMSLS_COL_LABELS, colLabels, 
      0);
}
